/*
 * This file contains subroutines to create python codes to 
 * create AST of OCL expression
 * 
 * We will have a general subroutine to creat relation object
 * And we will also have a general subroutine to creat different entity objects
 * Since they have different attributes, we will have a pointer to a linked list
 * of attributes as an argument
 *
 * Problems:
 * 1.How to determine the coordinates of the objects and their connections
 * 2.Everything is hard-coded, if the meta-model changes, all the functions
 *   may have to be changed.
 */

#define START_CNT 100



/* A linked list for attributes */
struct attribute
{
  char *name;
  char *value;
  struct attribute *next;
};
typedef struct attribute ATTRIB;



/*************************************************************************************
 * Creat python codes for all the neccessary imports classes
 *************************************************************************************/
void
creat_imports();

void
creat_init(char *fn_name);

void
creat_relation(char *rel_name, char *role, char *role2, float x, float y);

void
creat_propertyCallSource(float x, float y);

void
creat_operationCallArguments(float x, float y);

void
creat_referredVariable(float x, float y);

void
creat_referredAttribute(float x, float y);

void
creat_referredOperation(float x, float y);

void
creat_first(float x, float y);

void
creat_tail(float x, float y);

void 
creat_entity(char *entity_name, ATTRIB *attrib, float x, float y);

void
creat_Arguments(float x, float y);

void
creat_Operation(char *operator, float x, float y);

void
creat_AttributeCallExp(float x, float y);

void
creat_VariableExp(float x, float y);

void
creat_Attribute(char *attribute_name, float x, float y);

void
creat_StringLiteralExp(char *string_value, float x, float y);

void
creat_VariableDeclaration(char *varName, char *type, float x, float y);

void
creat_OperationCallExp(float x, float y);

void
connect(int i, int i2, int i3);

void
creat_end(char *fn_name);
